import { EventDefinition } from 'redux-beacon';
export declare const trackScreenView: (eventDef: EventDefinition<{
    screenName: string;
    customDimensions?: object;
}>) => EventDefinition<any>;
export declare const trackEvent: (eventDef: EventDefinition<{
    action: string;
    category: string;
    label?: string;
    value?: number;
    customDimensions?: object;
}>) => EventDefinition<any>;
export declare const trackPurchase: (eventDef: EventDefinition<{
    product: {
        id: string;
        name: string;
        category?: string;
        brand?: string;
        variant?: string;
        price?: number;
        quantity?: number;
        couponCode?: string;
    };
    transaction: {
        id: string;
        affiliation?: string;
        revenue?: number;
        tax?: number;
        shipping?: number;
    };
    action: string;
    category: string;
}>) => EventDefinition<any>;
export declare const trackTiming: (eventDef: EventDefinition<{
    category: string;
    value: number;
    name?: string;
    label?: string;
}>) => EventDefinition<any>;
export declare const trackSocialInteraction: (eventDef: EventDefinition<{
    network: string;
    action: string;
    target?: string;
}>) => EventDefinition<any>;
export declare const setUser: (eventDef: EventDefinition<string>) => EventDefinition<any>;
export declare const setClient: (eventDef: EventDefinition<string>) => EventDefinition<any>;
export declare const trackException: (eventDef: EventDefinition<{
    description: string;
    isFatal?: boolean;
}>) => EventDefinition<any>;
