"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
function GoogleAnalytics(trackingId, GoogleAnalyticsTracker) {
    var tracker = new GoogleAnalyticsTracker(trackingId);
    function target(events) {
        events.forEach(function (event) {
            switch (event.hitType) {
                case 'event': {
                    var options = {};
                    if (event.eventLabel !== undefined) {
                        options.label = event.eventLabel;
                    }
                    if (event.eventValue !== undefined) {
                        options.value = event.eventValue;
                    }
                    if (Object.keys(options).length > 0) {
                        tracker.trackEvent(event.eventCategory, event.eventAction, options);
                    }
                    else {
                        tracker.trackEvent(event.eventCategory, event.eventAction);
                    }
                    break;
                }
                case 'eventCustomDimensions': {
                    var options = {};
                    if (event.eventLabel !== undefined) {
                        options.label = event.eventLabel;
                    }
                    if (event.eventValue !== undefined) {
                        options.value = event.eventValue;
                    }
                    if (Object.keys(options).length > 0) {
                        tracker.trackEventWithCustomDimensionValues(event.eventCategory, event.eventAction, options, event.customDimensionDict);
                    }
                    else {
                        tracker.trackEventWithCustomDimensionValues(event.eventCategory, event.eventAction, {}, event.customDimensionDict);
                    }
                    break;
                }
                case 'pageview': {
                    tracker.trackScreenView(event.page);
                    break;
                }
                case 'pageviewCustomDimensions': {
                    tracker.trackScreenViewWithCustomDimensionValues(event.page, event.customDimensionDict);
                    break;
                }
                case 'timing': {
                    // timingVar is always required for timingLabel
                    if (event.timingVar !== undefined) {
                        var options = { name: event.timingVar };
                        if (event.timingLabel !== undefined) {
                            options.label = event.timingLabel;
                        }
                        tracker.trackTiming(event.timingCategory, event.timingValue, options);
                    }
                    else {
                        tracker.trackTiming(event.timingCategory, event.timingValue);
                    }
                    break;
                }
                case 'social': {
                    tracker.trackSocialInteraction(event.socialNetwork, event.socialAction, event.socialTarget);
                    break;
                }
                case 'user': {
                    tracker.setUser(event.userId);
                    break;
                }
                case 'client': {
                    tracker.setClient(event.clientId);
                    break;
                }
                case 'purchase': {
                    var productOptions_1 = {};
                    var optionalProductOptions = [
                        'category',
                        'brand',
                        'variant',
                        'price',
                        'quantity',
                        'couponCode',
                    ];
                    var transactionOptions_1 = {};
                    var optionalTransactionOptions = [
                        'affiliation',
                        'revenue',
                        'tax',
                        'shipping',
                        'couponCode',
                    ];
                    optionalProductOptions.forEach(function (option) {
                        if (event.product[option] !== undefined) {
                            productOptions_1[option] = event.product[option];
                        }
                    });
                    optionalTransactionOptions.forEach(function (option) {
                        if (event.transaction[option] !== undefined) {
                            transactionOptions_1[option] = event.transaction[option];
                        }
                    });
                    tracker.trackPurchaseEvent(__assign({ id: event.product.id, name: event.product.name }, productOptions_1), __assign({ id: event.transaction.id }, transactionOptions_1), event.eventCategory, // required
                    event.eventAction // required
                    );
                    break;
                }
                case 'exception': {
                    tracker.trackException(event.exDescription, event.exFatal);
                    break;
                }
                default:
            }
        });
    }
    return target;
}
exports.default = GoogleAnalytics;
